import gdata.youtube, webbrowser, time
import gdata.youtube.service
client = gdata.youtube.service.YouTubeService()

class Video:
  def __init__(self, calltitle, title, published, duration, category, tags, description, flash, page):
    self.calltitle = calltitle
    self.description = description
    self.title = title
    self.published = published
    self.duration = duration
    self.category = category
    self.tags = tags
    self.flash = flash
    self.page = page

def BreakLine(lines):
  for i in range(int(lines)):
    print ""

def SearchVideo(search_terms):
  yt_service = gdata.youtube.service.YouTubeService()
  yt_service.developer_key = 'AI39si7ADYchkpullu-OF3sBrSIczv5ZRWB2THRLsPvzftsehm4wUHRnGt5ERU7F9IN0b0KsWL0V_zwaoXqxgO2GjdD9U4h6HA'
  yt_service.client_id = 'ytapi-SeanDavis-YouTubeAdvanceSe-laj3g3io-0'
  query = gdata.youtube.service.YouTubeVideoQuery()
  query.vq = str(search_terms)
  query.max_results = query_results
  query.orderby = 'relevance'
  query.racy = 'exclude'
  feed = yt_service.YouTubeQuery(query)
  run_return = {}
  run_turn = 1
  for entry in feed.entry:
    video = Video
    video = video(str(entry.media.title.text) + "_" + str(entry.published.text), entry.media.title.text, str(entry.published.text)[0:10] + " at " + str(entry.published.text)[11:19], DurationFix(entry.media.duration.seconds), entry.media.category[0].text, entry.media.keywords.text, DescriptionFix(entry.media.description.text), entry.GetSwfUrl(), entry.media.player.url)
    run_return[run_turn] = {'title':video.title, 'published':video.published, 'duration':video.duration, 'category':video.category, 'tags':video.tags, 'flash':video.flash, 'page':video.page, 'description':video.description}
    run_turn = run_turn + 1
  return run_return

def DurationFix(duration):
  seconds = int(duration)
  if seconds >= 3600:
    hours = seconds / 3600
    seconds = seconds - hours*3600
  else:
    hours = '0'
  if seconds >= 60:
    minutes = seconds / 60
    seconds = seconds - minutes*60
  else:
    minutes = '00'
  if len(str(minutes)) == 1:
    minutes = '0' + str(minutes)
  if len(str(seconds)) == 1:
    seconds = '0' + str(seconds)
  return str(hours) + ":" + str(minutes) + ":" + str(seconds)

def DescriptionFix(description):
  if len(description) >= 250:
    description = description[:247] + "..."
  return description

def ReturnFeed(data):
  for k, v in data.iteritems():
    len_line = 24 - len(str(k))
    print str(k) + " " + "-"*len_line
    print str(v['title']) + " | " + str(v['published'])
    print "--"
    print str(v['duration']) + " | " + "Category: " + str(v['category']) + " | " + "Tags: " + str(v['tags'])
    print "--"
    print str(v['description'])
    print "--"
    print "URL: " + str(v['page'])
    BreakLine(1)

def PlayVideo(video):
  print "You are watching '" + video['title'] + "'."
  time.sleep(2.5)
  if video['flash'] == None:
    webbrowser.open_new(video['page'])
  else:
    webbrowser.open_new(video['flash'])

def PermitSearch(search, limits):
  search_permit = []
  for i in range(limits):
    search_permit.append(str(i + 1))
  search_permit.append('')
  if search == 'watch':
    search_permit.append('no')
  return search_permit


# While program_cycle is True, the program will continually run.        
program_cycle = True
while program_cycle == True:

    # While search_cycle is True, the basic search will run.  This was implemented to integrate a search restart.
    search_cycle = True
    while search_cycle == True:
      print "Welcome to pyTube, a Python-based YouTube search!"
      print "Please enter your search request or enter 'quit' to exit."
      search_query = raw_input("       Search for: ")
      if search_query == 'quit':
          BreakLine(2)
          program_cycle = False
          break
      elif search_query == '':
        continue

      # Requests number of desired search results.
      query_results_cycle = True
      while query_results_cycle == True:
        print "Please enter the number of desired results."
        query_results = raw_input("Number of Results: ")
        if query_results in PermitSearch('query', 50):
          if query_results == '':
              query_results = 10
              query_results_cycle = False
              break
          else:
            query_results_cycle = False
        else:
          print "A query request is allowed to be 50 at maximum."
          print "A query request must be a numeric value."
          BreakLine(2) 
          continue
      
      # Grabs and displays the results of the search.
      results = SearchVideo(search_query)
      if len(results) == 0:
        print "Believe it or not, there is no related results on YouTube..."
        BreakLine(1)
        search_cycle = False
        break
      ReturnFeed(results)

      # While video_cycle is True, the user will be prompted to watch any of the videos or cancel.
      video_cycle = True
      while video_cycle == True:
          BreakLine(1)
          print "Would you like to view any of these videos?"
          watch_video = raw_input("Enter the number of the video or enter 'no': ")
          if watch_video in PermitSearch('watch', int(query_results)):
            if watch_video == 'no':
                BreakLine(2)
                video_cycle = False
                break
            elif watch_video == '':
                watch_video = 1
          else:
              print "Please enter a number that is in the results."
              continue
          BreakLine(1)
          PlayVideo(results[int(watch_video)])
              

